CMAKE_MINIMUM_REQUIRED(VERSION 2.8.5 FATAL_ERROR)
PROJECT(hphp C CXX ASM)

set(HHVM_DEFINITIONS "HAVE_LIBDL;HAVE_CURL_MULTI_WAIT;U_USING_ICU_NAMESPACE=1;USE_JEMALLOC=1;NO_TCMALLOC=1;OPENSSL_NO_RAND_EGD;USE_EDITLINE;HHVM;HAVE_FT2BUILD;THRIFT_MUTEX_EMULATE_PTHREAD_TIMEDLOCK;HHVM_DYNAMIC_EXTENSION_DIR=\"@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/lib/hhvm/extensions\";_REENTRANT=1;_PTHREADS=1;__STDC_FORMAT_MACROS;NDEBUG;SKIP_USER_CHANGE=1;MAC_OS_X_VERSION_MIN_REQUIRED=MAC_OS_X_VERSION_10_6;MACOSX_DEPLOYMENT_TARGET=10.6;ENABLE_FASTCGI=1;NO_HARDWARE_COUNTERS=1;HPHP_OSS=1;PACKAGE=hhvm;PACKAGE_VERSION=Release;DEFAULT_CONFIG_DIR=\"@@HOMEBREW_PREFIX@@/etc/hhvm\";HAVE_INTTYPES_H;USE_CMAKE;PHP_MYSQL_UNIX_SOCK_ADDR=\"/tmp/mysql.sock\";HAVE_LIBBZIP2;HAVE_LIBCURL;HAVE_LIBXML2;HAVE_LIBICU;HAVE_LIBFREETYPE;HAVE_GD_FREETYPE;ENABLE_GD_TTF;HAVE_LIBJPEG;HAVE_GD_JPG;HAVE_ICONV;HAVE_LIBICONV;HAVE_LIBPNG;HAVE_GD_PNG;PNG_SKIP_SETJMP_CHECK;HAVE_LIBINTL;HAVE_LIBGMP;HAVE_LIBMAGICKWAND;HAVE_LIBLDAP;HAVE_LIBMCRYPT;HAVE_LIBMEMCACHED;HAVE_LIBEXPAT;HAVE_LIBXSLT;FOLLY_HAVE_MALLOC_H=0;FOLLY_NO_CONFIG=1;FOLLY_HAVE_PTHREAD=1;FOLLY_HAVE_RECVMMSG=0;FOLLY_HAVE_CLOCK_GETTIME=1;FOLLY_HAVE_PTHREAD_ATFORK=1;FOLLY_HAVE_PTHREAD_SPINLOCK_T=0;FOLLY_USE_LIBCPP=1;FOLLY_HAVE_LIBDWARF_DWARF_H=0;FOLLY_HAVE_VLA=1;FOLLY_HAVE_IFUNC=0;FOLLY_HAVE_BITS_FUNCTEXCEPT_H=0;FOLLY_HAVE_LINUX_MEMBARRIER_H=0;FOLLY_HAVE_WEAK_SYMBOLS=0;FOLLY_HAVE_MEMRCHR=0;FOLLY_HAVE_PREADV=0;FOLLY_HAVE_PWRITEV=0;FOLLY_HAVE_LIBGFLAGS=0;NO_LIB_GFLAGS;FOLLY_HAVE_SCHED_H=1")
set(HHVM_VERSION_BRANCH "40132")
set(CMAKE_INSTALL_PREFIX "@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31")
set(CMAKE_INSTALL_LIBDIR "lib")
set(CMAKE_BUILD_TYPE "RelWithDebInfo")

option(HHVM_DSO_TEST_MODE "Build against source headers, not installed ones" Off)
if (HHVM_DSO_TEST_MODE)
  set(HHVM_INCLUDE_DIRS "/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31;/Library/Developer/CommandLineTools/SDKs/MacOSX10.14.sdk/usr/include;@@HOMEBREW_PREFIX@@/include;@@HOMEBREW_PREFIX@@/opt/libxml2/include/libxml2;@@HOMEBREW_PREFIX@@/opt/sqlite/include;@@HOMEBREW_PREFIX@@/include/double-conversion;@@HOMEBREW_PREFIX@@/opt/icu4c/include;@@HOMEBREW_PREFIX@@/opt/openssl@1.1/include;@@HOMEBREW_PREFIX@@/include/libelf;/Library/Developer/CommandLineTools/SDKs/MacOSX10.14.sdk/usr/include/security;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/hphp;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/forks/libmbfl;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/forks/libmbfl/mbfl;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/forks/libmbfl/filters;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/forks/timelib;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/forks/folly/src;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/fatal;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/fizz/src;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/wangle/src;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/proxygen/src;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/fmt/fmt/include;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/thrift/src;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/thrift/gen;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/libafdt/src/src;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/fastlz/src;@@HOMEBREW_CELLAR@@/libsodium/1.0.18_1/include;$<TARGET_PROPERTY:onig,INTERFACE_INCLUDE_DIRECTORIES>;@@HOMEBREW_PREFIX@@/include/freetype2;@@HOMEBREW_CELLAR@@/imagemagick@6/6.9.11-28/include/ImageMagick-6;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/folly/src;/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/third-party/folly")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/CMake" "/tmp/hhvm-nightly-20200831-50913-1dh02m5/hhvm-nightly-2020.08.31/hphp/public_tld/CMake"
    ${CMAKE_MODULE_PATH})
else()
  set(HHVM_INCLUDE_DIRS "@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include;/Library/Developer/CommandLineTools/SDKs/MacOSX10.14.sdk/usr/include;@@HOMEBREW_PREFIX@@/include;@@HOMEBREW_PREFIX@@/opt/libxml2/include/libxml2;@@HOMEBREW_PREFIX@@/opt/sqlite/include;@@HOMEBREW_PREFIX@@/include/double-conversion;@@HOMEBREW_PREFIX@@/opt/icu4c/include;@@HOMEBREW_PREFIX@@/opt/openssl@1.1/include;@@HOMEBREW_PREFIX@@/include/libelf;/Library/Developer/CommandLineTools/SDKs/MacOSX10.14.sdk/usr/include/security;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/forks/libmbfl;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/forks/libmbfl/mbfl;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/forks/libmbfl/filters;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/forks/timelib;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/forks/folly/src;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/fatal;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/fizz/src;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/wangle/src;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/proxygen/src;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/fmt/fmt/include;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/thrift/src;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/thrift/gen;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/libafdt/src/src;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/fastlz/src;@@HOMEBREW_CELLAR@@/libsodium/1.0.18_1/include;$<TARGET_PROPERTY:onig,INTERFACE_INCLUDE_DIRECTORIES>;@@HOMEBREW_PREFIX@@/include/freetype2;@@HOMEBREW_CELLAR@@/imagemagick@6/6.9.11-28/include/ImageMagick-6;@@HOMEBREW_CELLAR@@/hhvm-nightly/2020.08.31/include/hphp/third-party/folly/src")
  set(CMAKE_MODULE_PATH
    ${CMAKE_CURRENT_SOURCE_DIR}
    "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/hhvm/CMake"
    ${CMAKE_MODULE_PATH})
endif()

message(STATUS "Configuring for HHVM API version ${HHVM_VERSION_BRANCH}")

include(HPHPFunctions)
include(HPHPIZEFunctions)
include(HPHPCompiler)
include(config)

foreach (dir ${HHVM_INCLUDE_DIRS})
  include_directories(${dir})
endforeach()

add_definitions("-DHHVM_BUILD_DSO")
foreach (def ${HHVM_DEFINITIONS})
  add_definitions("-D${def}")
endforeach()

add_custom_target(test COMMAND
                       HHVM_BIN=${CMAKE_INSTALL_PREFIX}/bin/hhvm
                       ${CMAKE_CURRENT_SOURCE_DIR}/run-test
                       -a "-vDynamicExtensions.99=${EXTENSION_NAME}.so" test
                       DEPENDS ${EXTENSION_NAME})
